program apinteg

  ! Original version by M. Hamabe 2001-09-06 (SPIRAL version2.6)  
  ! Updated by H. Shimizu 2007-09-19 (for Fortran90)
  ! Updated by M. Hamabe  2007-11-02 (opninp etc)
  ! Updated by H. Shimizu & M. Hamabe  2008-01-15 (read REG file)
  
  real,allocatable :: G(:,:)
  character :: image*80, nlpf*80, subtra*3, title*40, center*3
  character :: interact*5, regfile*30
  integer   :: im, irc
  real      :: x(100000), y(100000), z(100000)
  
  nlp =21
  kext=100000
  
  !     open image in READ-only mode
  call opninp (1,im,0,image,title,iext,jext,irc)
  if ( irc /= 0 ) go to 999
  
  call opniaf (image,'ap',nlpf,nlp,irc)
  if ( irc /= 0 ) stop
  
  call CLARGC (2, subtra, irc)
  if ( irc /= 0 ) then
     irc = 0
     subtra='yes'
  end if
  
  call CLARGR (3, fctm, irc)
  if ( irc /= 0 .and. subtra /= 'no' ) then
     irc = 0
     print '("Enter Margin area factor for fitting : ",$)'
     read *, fctm
     if ( fctm < 1.2 ) fctm=1.2
     if ( fctm > 5.0 ) fctm=5.0
  end if
  if ( subtra == 'no' ) fctm=0.0
  
  call CLARGC (4, center, irc)
  if ( irc /= 0 ) center='no'

  call CLARGC (5, interact, irc)
  if ( irc /= 0 ) interact='yes'

  call CLARGC (6, regfile, irc)
  if ( irc /= 0 ) regfile='ds9.reg'

  call GETKEYE(im, 'CDELT1  ',psize,irc)
  if ( irc /= 0 ) call GETKEYE(im,'SECPPIX ',psize,irc)
  psize=abs(psize)
  if ( psize < 10/3600.0 ) psize=psize*3600.0
  if ( psize < 0.001 .or. psize > 10.0 ) irc=1
  if ( irc /= 0 ) then
     print '("Enter pixel size in unit of arcsec/pixel      ===> ",$)'
     read *, psize
     irc=0
  end if
  print '("     Pixel size    =",f6.3,"(arcsec)")', psize
  
  allocate( G(iext,jext) )
  CALL matrd(im,G,iext,jext,irc)
  if ( irc /= 0 ) go to 999
  
  call GETKEYE(im, 'EXPTIME ', expt,irc)
  if ( irc /= 0 ) call GETKEYE(im,'EXPT    ', expt,irc)
  if ( irc /= 0 ) call GETKEYE(im,'ITIME   ', expt,irc)
  if ( irc /= 0 ) call GETKEYE(im,'OTIME   ', expt,irc)
  if ( irc /= 0 ) then
     print '("Exposure time (sec) ===> ",$)'
     read *, expt
  end if
  print '("     Exposure time =",f6.1,"(sec)")', expt
  
  CALL APINTG(G,iext,jext,psize,x,y,z,kext,title,interact,regfile, &
       & expt,subtra,fctm,center,nlp)
  
9000 deallocate(G) 
  call PGEND
  stop
  
999 call PUTEMSG(irc)
  call PGEND
  
  stop
END program apinteg

!------------------------------------------------------------------
SUBROUTINE APINTG(G,iext,jext,psize,x,y,z,kext,title,interact,regfile, &
     & expt,sub,F,center,nlp)
  
  !     *** APERTURE INTEGRATION ***
  
  character :: title*(*), interact*5, regfile*30, line*80
  character :: sub*(*), device*20, center*(*), ch, yn, ok*3
  real      :: G(iext,jext)
  real      :: x(kext), y(kext), z(kext)
  
  IFLG=-999
  device='/XWINDOW'
  ipal=1
  IW1=IFLG
 
  ok='Ok '

  if ( interact == 'yes' ) then ! interactive mode
     print *
     print *, '***** APERTURE INTEGRATION *****'
     call SPG_OPN(IW1,IFLG,device)
     if ( iext >= (jext*1.75) ) then
        width=10.0 !7.0
        ratio=real(jext)/real(iext)*1.25
     else if ( iext >= jext .or. jext < (iext*1.2) ) then
        width=12.0 ! 5.0
        ratio=real(jext)/real(iext)*1.2
     else
        hight=12.0 ! 8.0
        ratio=real(jext)/real(iext)*1.1
        width=hight/ratio
     end if
     
     !     Set up graphics device to display image.
     call PGPAP(width, ratio)  ! set the size and aspect
     call PGSVP(0.0,1.0,0.0,1.0)
     call PGSWIN(0.0,1.0,0.0,1.0)
     call PGSCR(0, 0.4, 0.4, 0.4) ! set color representation 
     call PGSFS(2)
     IS=iext/8
     ie=iext/3
     JS=jext/8
     JE=jEXT/3
     FACT=3.0
     NCYCLE=2
     
     CALL STATRJ(G,iext,jext,IS,IE,JS,JE,FACT,NCYCLE,GMAX,GMIN,GMEAN,GSD,NREJ,irc)
     print '("max.=",F12.3,2X,"min.=",f12.3,2x,"mean=",F12.3,2X,"S.D.=",F12.3)', &
          &  GMAX,GMIN,GMEAN,GSD
     
     rmin=gmean-gsd
     rmax=gmean+5*gsd
     if ( rmin <= 0.0 ) rmin=0.002
     
777  continue
     print *, 'displaying orignal image in linear scale ...'
     print *, 'z1=',rmin,' z2=',rmax
     call SPG_DSP(G,iext,jext,title,Rmin,Rmax,IPAL,IW,1,1,iext,jext)
     print '("Is display level OK? ",$)'
     read '(a)', yn
     if ( yn == 'n' ) then
        print '("z1,z2 = ",$)'
        read *, rmin, rmax
        if ( rmin <= 0.0 ) rmin= 0.001
        goto 777
     end if
     
     NOBJ=0
     
     print *
     
     !     *** READ PARAMETERS ***
200  CONTINUE
     irepeat=0
     krec=0
     print *
     print '(a,$)', 'New  position; '
     print '(''Enter max AP (D(max)"; 0 for quit) ===> '',$)'
     read *, APmax
     PIXmax=APmax/psize/2.0
     if ( APmax == 0 ) return
     call SPG_DSP(G,iext,jext,title,Rmin,Rmax,IPAL,IW,1,1,iext,jext)
     write(nlp,*) 'Obj   Xc     Yc     peak   D(")   Npix   F     Count'
     !     *** READ COORDINATE ***
400  CONTINUE
     NOBJ=NOBJ+1
     print *
     irepeat=0
     ap=int(apmax/1.5)
     idum=iext/2
     jdum=jext/2
     PIX=ap/psize/2.0 
     do while ( PIX.lt.PIXmax )
        if ( irepeat.eq.0 ) then
           print *, 'Locate cursor and press left button.  (right for quit)'
           call PGCURS(xx,yy,ch)
           if ( center=='yes' ) then
!              print *,'image center is being re-defined...'
              ! find center of gravity
              il=xx-5
              ih=xx+5
              jl=yy-5
              jh=yy+5
              call cenofgr(G,iext,jext,il,ih,jl,jh,xx,yy)
           end if
           xxc=xx
           yyc=yy
           idum=nint(xx)
           jdum=nint(yy)
           print '("Obj=",i3,", C=(",f8.2,",",f8.2,")  peak=",f10.2, &
                &    "  margin=",f4.1)',  NOBJ, xx, yy, G(idum,jdum),f
        end if
        if  ( ch.ne.'X' .or. irepeat.eq.1  ) then
           irepeat=1
           AP=AP+1.0
           PIX=AP/psize/2.0
           xx=idum
           yy=jdum
           ii=idum
           jj=jdum
           if ( ii < 1.or.ii > iext.or.jj < 1.or.jj > jext)  go to 200
           !     *** OBTAIN INTEGRATION VALUE ***
           if ( sub=='no' ) then  ! including sky
              call CINTEG(g,iext,jext,xx,yy,pix,1,0,1.0,0,val,pnum,x,y,z,kext,krec)
           else                   ! sky subtracted
              call CINTEG(g,iext,jext,xx,yy,pix,1,1,  f,1,val,pnum,x,y,z,kext,krec)
           end if
           if ( krec /= 0 ) then
              if ( krec==3000) then
                 print *, 'background fitting error!'
                 ok='*  '
              else
                 print *, 'return code =',krec
                 print *
                 ok='Err'
                 val=0.0
                 write(nlp,'(i4,2(f7.2),f9.2,f5.1,f8.1,f4.1,G15.7)') &
                      & NOBJ, xxc, yyc,G(nint(xxc),nint(yyc)),ap,pnum,f,val/expt
                 go to 200
              end if
           end if
           print '(''     D(")='',f6.1,'', NP='',F9.2,'', I(/sec)='',G15.7)',  &
                &  AP, PNUM, VAL/expt
           write(nlp,'(i4,2(f7.2),f9.2,f5.1,f8.1,f4.1,G15.7,2x,a3)') &
                & NOBJ, xxc, yyc,G(nint(xxc),nint(yyc)),ap,pnum,f,val/expt,ok
           ok='Ok '
        end if
     end do
     call PGCIRC(Xx,Yy,pix)
     rf=pix*f
     call PGCIRC(xx,yy,rf)
     
     go to 200
     
     !  %%%%%   for using region file   %%%%%
  else      ! NON-interactive mode
     NOBJ=0
     write(nlp,*) 'Obj   Xc     Yc     peak   D(")   Npix   F     Count'
     open(11, file=regfile)
     do i=1, 999
        read(11, '(a70)', end=600) line
        is=index(line, '(')+1
        ie=index(line, ')')-1
        if ( line(1:3)=='phy' ) then
           print *
           print *, '##### ERROR: change file coordinate system from "physical" to "image"'
           print *
           stop
        end if
        if ( line(1:3)=='cir' ) then
           NOBJ=NOBJ+1
           read( line(is:ie), *) xx, yy, rad
           APmax=rad*2.0
           PIXmax=APmax/PSIZE/2.0
!           print *,'image center is being re-defined...'
           ! find center of gravity
           il=xx-5
           ih=xx+5
           jl=yy-5
           jh=yy+5
           call cenofgr(G,iext,jext,il,ih,jl,jh,xx,yy)
           xxc=xx
           yyc=yy
           idum=nint(xx)
           jdum=nint(yy)     
           print '("Obj=",i3,", C=(",f8.2,",",f8.2,")  peak=",f10.2, &
                &    "  margin=",f4.1)',  NOBJ, xx, yy, G(idum,jdum),f
           AP=int(APmax/1.5)
           PIX=ap/psize/2.0
           do while ( PIX<=PIXmax )
              xx=idum
              yy=jdum
              ii=idum
              jj=jdum
              if ( ii < 1.or.ii > iext.or.jj < 1.or.jj > jext) then
                 print *, 'Circle is out of image !! '
                 go to 600
              end if
             !     *** OBTAIN INTEGRATION VALUE ***
              if ( sub=='no' ) then  ! including sky
                 call CINTEG(g,iext,jext,xx,yy,pix,1,0,1.0,0,val,pnum,x,y,z,kext,krec)
              else                   ! sky subtracted
                 call CINTEG(g,iext,jext,xx,yy,pix,1,1,  f,1,val,pnum,x,y,z,kext,krec)
              end if
              if ( krec /= 0 ) then
                 if ( krec==3000) then
                    print *, 'background fitting error!'
                    ok='*  '
                 else
                    print *, 'return code =',krec
                    print *
                    ok='Err'
                    krec=0
                    pnum=0.0
                    val=0.0
                    write(nlp,'(i4,2(f7.2),f9.2,f5.1,f8.1,f4.1,G15.7,2x,a3)') &
                         & NOBJ, xxc, yyc,G(nint(xxc),nint(yyc)),ap,pnum,f,val/expt,ok
                    go to 602
                 end if
              end if
              !     *** DISPLAY RESULTS ***
              print '(''     D(")='',f6.1,'', NP='',F9.2,'', I(/sec)='',G15.7)',  &
                   &  AP, PNUM, VAL/expt
              write(nlp,'(i4,2(f7.2),f9.2,f5.1,f8.1,f4.1,G15.7,2x,a3)') &
                   & NOBJ, xxc, yyc,G(nint(xxc),nint(yyc)),ap,pnum,f,val/expt,ok
              ok='Ok'
              AP=AP+1.0
              PIX=AP/psize/2.0
           end do
        end if
        602 continue
     end do
  end if
  
600 close(11)
  
end SUBROUTINE APINTG

!--------------------------------------------------------------------
SUBROUTINE CENOFGR(G,iext,jext,IL,IH,JL,JH,XC,YC)
  
  !     Calculate the center of gravity in submatrix.
  
  real :: g(iext,jext)
  
  cmax=-99999.0
  do i=il,ih
     if ( g(i,jl) >= cmax ) cmax=g(i,jl)
     if ( g(i,jh) >= cmax ) cmax=g(i,jh)
  end do
  do j=jl,jh
     if ( g(il,j) >= cmax ) cmax=g(il,j)
     if ( g(ih,j) >= cmax ) cmax=g(ih,j)
  end do
  
  wt=0.0
  xc=0
  yc=0
  do j=jl,jh
     do i=il,ih
        if ( g(i,j) >= cmax ) then
           wt=wt+g(i,j)
           xc=xc+real(i)*g(i,j)
           yc=yc+real(j)*g(i,j)
        end if
     end do
  end do
  xc=xc/wt
  yc=yc/wt
  
  return
end SUBROUTINE CENOFGR
