program badpix
  
  ! Original version by M. Hamabe 2004-04-30 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-09-18 (for Fortran90)
  ! Updated by H. Shimizu 2007-10-23 (opninp)

  character image*80, colist*80, comments*50
  character title*40, cnum*9, mode
  integer   im, irc, bitpix
  real, allocatable :: G(:,:)
  
  lin=11
  
  print *
  call opninp (1,im,0,image,title,iext,jext,irc)
  if ( irc/=0 ) go to 999
  
  call clargc (2, image, irc)
  if ( irc /= 0 ) then
     print '("Enter       output   image name: ",$)'
     read *, image
     irc=0
  end if

  call FTGKYJ(im,'BITPIX',bitpix,comments,irc)

  call IMGCOPY(im,nim,bitpix,image,irc)
  if ( irc /= 0 ) goto 999
  
  call clargc (3, colist, irc)
  if ( irc /= 0 ) then
     print '("Enter file name for bad-col. list: ",$)'
     read *, colist
     irc=0
  end if
  
  call GETKEYE(im,'BLANK',vnull,irc)
  if ( irc /= 0 ) then
     print '("Enter value for null pixel: ",$)'
     read *, vnull
     irc=0
  end if
  print *,'Adopted Null Value = ',vnull
  
  allocate( G(iext, jext) )
  CALL MATRD(im,G,IEXT,JEXT,irc)
  if ( irc /= 0 ) go to 999
  call FCLOSE(im,irc)
  if ( irc /= 0 ) go to 999
  
  call adhstry(nim,'BADPIX',6, ' BAD PIXELS WERE CORRECTED', irc)
  
  if ( colist == 'keyin' ) then
     print '("Type in pixel coordinate (Return for end)")'
1000 continue
     print '("Starting column (Istart) : ",$)'
     read '(a)', cnum
     if ( cnum == '         ' ) go to 2000
     read (cnum,*) is
     print '("Ending   column (Iend)   : ",$)'
     read '(a)', cnum
     if ( cnum == '         ' ) go to 2000
     read (cnum,*) ie
     print '("Starting  row   (Jstart) : ",$)'
     read '(a)', cnum
     if ( cnum == '         ' ) go to 2000
     read (cnum,*) js
     print '("Ending    row   (Jend)   : ",$)'
     read '(a)', cnum
     if ( cnum == '         ' ) go to 2000
     read (cnum,*) je
     print '("Interpolate or Null? (<i>/n) : ",$)'
     read '(a)', mode
     if ( mode/='n' ) mode='i'
     call corpix(G,iext,jext,is,ie,js,je,mode,vnull)
     write(comments,'("  IS=",i5,", IE=",i5, &
          &       ", JS=",i5,", JE=",i5,", Mode=",a)') is,ie,js,je,mode
     call adhstry(nim,'BADPIX',0,comments,irc)
     go to 1000
  else
     open (lin,file=colist,access='SEQUENTIAL',status='OLD')
1001 read (lin,*,end=2000)  is,ie,js,je,mode
     print '(4i6,2x,a1)', is,ie,js,je,mode
     call corpix(G,iext,jext,is,ie,js,je,mode,vnull)
     write(comments,'(" IS=",i5,", IE=",i5, &
          &       ", JS=",i5,", JE=",i5,", Mode=",a)') is,ie,js,je,mode
     call adhstry(nim,'BADPIX',0,comments,irc)
     go to 1001
  end if
  
2000 continue
  CALL MATWT (nim,G,iext,jext,irc)
  if ( irc /= 0 ) go to 999
  call FCLOSE(nim,irc)
  if ( irc /= 0 ) go to 999
  
9000 STOP
  
999 close(lin)
  call PUTEMSG(irc)
  stop
  
END program badpix
!-------------------------------------------------------------------
subroutine corpix(G,iext,jext,is,ie,js,je,mode,vnull)
  
  dimension g(iext,jext)
  character mode
  
  lrow=abs(ie-is)
  lcol=abs(je-js)
  
  if ( mode == 'n' ) then
     g(is:ie,js:je)=vnull
  else
     if ( lcol >= lrow ) then ! vertical-strip
        do j=js, je
           do i=is, ie
              w=float(ie-is+2)
              w1=float(ie-i+1)
              w2=float(i-is+1)
              s0=(g(is-1,j)*w1+g(ie+1,j)*w2)/w
              j1=i+j-is+1
              if ( j1 > jext ) j1=jext
              j2=i+j-ie-1
              if ( j2 < 1 ) j2=1
              s1=(g(is-1,j1)*w1+g(ie+1,j2)*w2)/w
              j1=j-i+is-1
              if ( j1 < 1 ) j1=1
              j2=j-i+ie+1
              if ( j2 > jext ) j2=jext
              s2=(g(is-1,j1)*w1+g(ie+1,j2)*w2)/w
              g(i,j)=(s0+s1+s2)/3.0
           end do
        end do
     else                   ! horizontal-strip
        do i=is, ie
           do j=js, je
              w=float(je-js+2)
              w1=float(je-j+1)
              w2=float(j-js+1)
              s0=(g(i,js-1)*w1+g(i,je+1)*w2)/w
              i1=i+j-js+1
              if ( i1 > iext ) i1=iext
              i2=i+j-je-1
              if ( i2 < 1 ) i2=1
              s1=(g(i1,js-1)*w1+g(i2,je+1)*w2)/w
              i1=i-j+js-1
              if ( i1 < 1 ) i1=1
              i2=i-j+je+1
              if ( i2 > iext ) i2=iext
              s2=(g(i1,js-1)*w1+g(i2,je+1)*w2)/w
              g(i,j)=(s0+s1+s2)/3.0
           end do
        end do
     end if
  end if
  
  return
END subroutine corpix
