program eqprof2
  
  ! Original version by M. Hamabe 1996-08-27 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-10-16 (for Fortran90)
  ! Checked by M. Hamabe  2007-10-22

  character OBJECT*40,model*20,tmpfile*40,outfile*40
  character image*80, hcopy*5, hdev*6, hfile*40
  dimension AMG(51),ALG(51),DLTL(51),SGML(51),REQ(51),FRAC(51)
  dimension RHO(51),ALJ(51),AMU(3),RE(3)
  
  LIN =11
  NLP =16
  
  call clargc (1, tmpfile, ier)
  if ( ier/=0 ) then
     print '(''Enter name of temporary file ===> '',$)'
     read '(a)', tmpfile
  end if
  open (LIN, file=tmpfile,access='SEQUENTIAL')
  read (LIN,'(a)',end=999) image
  
  call opniaf(image,'eqprf', outfile, NLP,irc)
  if ( irc/=0 ) stop
  
  call clargc (2, hcopy, ier)
  if ( ier/=0 ) hcopy='no'
  call clargc (3, hdev, ier)
  if ( hdev(1:4)=='lips' ) then
     hdev='/lips'
  else 
     hdev='/PS'
  end if
  call clargc (4, hfile, ier)
  if ( ier/=0 ) then
     if ( hdev=='/vlips' ) then
        hfile='eqprof.lps'
     else
        hfile='eqprof.ps'
     end if
  end if
  
  !***** read output data from eqprof1
  call EQPDAT (OBJECT,AREA,SKY,model,AMG,ALG,DLTL,SGML,REQ,W1,W2,NDAT,LIN,NLP)
  
  !***** calculate total luminosity & fraction
  call EQPEXT (model,ALG,SGML,REQ,FRAC,W1,W2,DEL,TTL,NDAT)
  
  !***** calculate effective parameters
  call EFFPAR (AMG,REQ,FRAC,FR25,IVF,RE,AMU,C21,C32,NDAT)
  
  !***** calculate reduced equivalent profile
  call REDEQP (ALG,REQ,SKY,AMU(2),RE(2),RHO,ALJ,NDAT)
  
  !***** print result
  call PRINTR(OBJECT,SKY,AREA,DEL,TTL,AMG,ALG,DLTL,SGML,FRAC,REQ,RHO,ALJ, &
       &      FR25,IVF,RE,AMU,C21,C32,NDAT,outfile,NLP)
  
  !***** PLOT EQUIVALENT PROFILE
  if ( hcopy=='yes' ) call PLOTEQ(OBJECT,AMG,REQ,RHO,ALJ,NDAT,hdev,hfile)
  
999 stop
END program eqprof2

!---- EQPDAT ----------------------------------------------------------
SUBROUTINE EQPDAT (OBJECT,AREA,SKY,model,AMG,ALG,DLTL,SGML,REQ,Y1,Y2,N,LIN,NLP)

  character TITLE*40,model*20,OBJECT*40
  dimension AMG(51),ALG(51),DLTL(51),SGML(51),REQ(51)
  dimension TABLE(5,51)! ,ITABLE(51),NPX(51)
  data PI/3.141593/

  read(LIN,'(A40)')       TITLE
  OBJECT=TITLE(1:40)
  read(LIN,'(10X,F15.0)') AREA
  read(LIN,'(10X,2I5)')   IC,JC
  read(LIN,'(10X,F10.0)') SKY
  read(LIN,'(10X,F10.0)') A
  read(LIN,'(10X,F10.0)') AXRAT
  read(LIN,'(10X,F10.0)') THETA
  read(LIN,'(10X,I10)')   NTOT
  read(LIN,'(10X,I10)')   NEFF
  read(LIN,'(10X,F10.0)') PEAK
  read(LIN,*)
  do J=1,51
!     read(LIN,'(2F10.0,F15.0,I10,2F15.0)') &
!          &    ( TABLE(I,J),I=1,3 ),ITABLE(J),( TABLE(I,J),I=4,5 )
     read(LIN,'(2F10.0,F15.0,10X,2F15.0)') &
          &    ( TABLE(I,J),I=1, 5 )
  end do
  
  read (LIN,'(A20)') model
  read (LIN,'(10X,F10.0)') Y1
  read (LIN,'(10X,F10.0)') Y2
  
  ALG(1)=LOG10(PEAK)
  AMG(1)  =-2.5*ALG(1)+SKY
  REQ(1)  =SQRT(AREA/PI)
!  NPX(1)  =1
  DLTL(1) =PEAK*AREA
  SGML(1) =DLTL(1)
  
  N=1
  do J=1,51
     if( TABLE(2,J)<=ALG(1) .and. TABLE(2,J)>=Y2 ) then
        N=N+1
        if( N==2 ) then
           AMG(N) =TABLE(1,J)
           ALG(N) =TABLE(2,J)
           REQ(N) =TABLE(3,J)
!           NPX(N) =ITABLE(J)-1
           DLTL(N)=TABLE(4,J)-DLTL(1)
           SGML(N)=TABLE(5,J)
        else
           AMG(N) =TABLE(1,J)
           ALG(N) =TABLE(2,J)
           REQ(N) =TABLE(3,J)
!           NPX(N) =ITABLE(J)
           DLTL(N)=TABLE(4,J)
           SGML(N)=TABLE(5,J)
        end if
     end if
  end do
  
  write(NLP,'('' '')')
  
  write(NLP,'('' ''10X,''Data title : '',A40)') TITLE
  write(NLP,'('' ''10X,''Mesh size  : '',G12.3,'' (arcmin**2); '',F9.4, &
       &      '' (arcsec)'')') AREA, SQRT(AREA)*60
  write(NLP,'('' ''10X,''Sky mag.   : '',F10.3,'' (mag/arcsec**2)'')') SKY
  write(NLP,'('' ''10X,''Peak mag.  : '',F10.3,'' (mag/arcsec**2)'')') &
       & -2.5*LOG10(PEAK)+SKY
  
  write(NLP,'('' ''10X,''Data sampling area '')')
  write(NLP,'('' ''20X,''Center          : ('',I5,'','',I5,'')'')')  IC,JC
  write(NLP,'('' ''20X,''Semi-major axis : '',F10.2,'' (mesh)'')') A
  write(NLP,'('' ''20X,''Axis ratio (b/a): '',f10.2)') AXRAT
  THETA0=THETA+270.0
  if (theta0>360.0 ) theta0=theta0-360.0
  write(NLP,'('' ''20X,''Position angle  : '',F10.2,'' (deg.)'')') THETA0
  write(NLP,'('' ''20X,''Number of pixels: '',I7,''/'',I7,&
       &      '' (eff./total)'')') NEFF,NTOT
  
  write(NLP,'('' ''10X,''Parameters for extrapolation'')')
  write(nlp,'('' ''20x,''Function form   : '',A20)') model
  write(NLP,'('' ''20X,''Limitting  log I: '',F10.3)') Y2
  write(NLP,'('' ''20X,''Luminosity gradient are derived '')')
  write(nlp,'('' ''30x,''from  log I ='',F5.1,'' and  '', &
       &               ''log I ='',F5.1///)') Y1,Y2
  
  return
END SUBROUTINE EQPDAT

!---- EQPEXT -----------------------------------------------------------
SUBROUTINE EQPEXT (model,ALG,SGML,REQ,FRAC,Y1,Y2,DELTA,TOTAL,NDAT)

  character model*20
  dimension ALG(51),SGML(51),REQ(51),FRAC(51)
  data PI/3.141593/

  do J=1,NDAT
     EPS1=ABS( ALG(J)-Y1 )
     EPS2=ABS( ALG(J)-Y2 )
     if( EPS1<0.001 ) X1=REQ(J)
     if( EPS2<0.001 ) X2=REQ(J)
  end do
  
  CONST=LOG10( EXP(1.0) )
  AI=10.0**Y2
  U=Y1-Y2
  if( model(1:3)=='EXP' ) then
     V=CONST*(X2-X1)
     ALP=U/V
     U=2.0*PI*AI*(ALP*X2+1.0)
     V=ALP*ALP
     DELTA=U/V
  else
     V=CONST*( X2**(0.25) - X1**(0.25) )
     BET=U/V
     G=BET*X2**(0.25)
     A=   7.0
     B=  42.0
     C= 210.0
     D= 840.0
     E=2520.0
     F=5040.0
     U=8.0*PI*AI*(  G*(G*(G*(G*(G*(G*(G+A)+B)+C)+D)+E)+F)+F  )
     V=BET**8
     DELTA=U/V
  end if
  TOTAL=SGML(NDAT)+DELTA
  
  do J=1,NDAT
     FRAC(J)=SGML(J)/TOTAL
  end do
  
  return
END SUBROUTINE EQPEXT

! --- EFFPAR ----------------------------------------------------------
SUBROUTINE EFFPAR (AMG,REQ,FRAC,FR25,IVF,RE,AMU,C21,C32,N)
  dimension AMG(51),REQ(51),FRAC(51),AMU(3),RE(3)
  
  do I=1,3
     VAL=I*0.25
     call EQPINT(FRAC,REQ,RE(I) ,VAL,N,IRC)
     call EQPINT(FRAC,AMG,AMU(I),VAL,N,IRC)
  end do
  
  IVF=25
1 VALFR=IVF
  call EQPINT(AMG, FRAC, FR25, VALFR , N, IRC)
  if( IRC/=0 ) then
     IVF=IVF-1
     go to 1
  end if
  
  C21=RE(2)/RE(1)
  C32=RE(3)/RE(2)
  
  return
END SUBROUTINE EFFPAR

!---- EQPINT ---------------------------------------------
SUBROUTINE EQPINT (U,V,PAR,Z,N,IRC)
  dimension U(51),V(51),X(4),Y(4),sigmaY(4),C(4)

  K=0
  IRC=0
  do J=1,N
     if( U(J)>=Z ) then
        K=J
        go to 1000
     end if
  end do
  if( K==0 .OR. (K+1)>N ) then
     IRC=1
     return
  end if
  
1000 CONTINUE
  do I=1,4
     X(I)=U(K+I-3)
     Y(I)=V(K+I-3)
  end do

!     order of polynom. was reduced (3 -> 2) 1991-10-27
  call LESQ1 (X, Y, SIGMAY, 4, 3, 0, C, CHISQR)
  
  PAR  =  C(1)  +  C(2)*Z  +  C(3)*Z*Z  

  return
END SUBROUTINE EQPINT

!---- REDEQP ---------------------------------------------
SUBROUTINE REDEQP (ALOGI,REQ,SKY,AME,RE,RHO,ALOGJ,N)
  dimension ALOGI(51),REQ(51),RHO(51),ALOGJ(51)

  SHIFT=-(SKY-AME)/2.5
  do J=1,N
     RHO(J)=REQ(J)/RE
     ALOGJ(J)=ALOGI(J)+SHIFT
  end do

  return

END SUBROUTINE REDEQP

!---- PRINTR ---------------------------------------------
SUBROUTINE PRINTR(OBJECT,SKY,AREA,DEL,TTL, &
     &            AMG,ALG,DLTL,SGML,FRAC,REQ,RHO,ALJ, &
     &            FR25,IVF,RE,AMU,C21,C32,N,outfile,NLP)
  character OBJECT*40,CK(3)*3,CR(3)*5,CMU(3)*3,outfile*40
  dimension AMG(51),ALG(51),DLTL(51),SGML(51),REQ(51),FRAC(51)
  dimension RHO(51),ALJ(51),AMU(3),RE(3)
  data  CK/'1/4','1/2','3/4'/
  data  CR/'R1(*)','RE(*)','R3(*)'/
  data CMU/'MU1','MUE','MU3'/
  
  !     ----- print a table of mean luminosity distribution

  write(NLP,'('' '',11X,''Mean luminosity distribution in '',a40/ &
       &      1x,77(''_'')//7x,''mu'',4x,''log I'',6X, &
       &      ''d L'',6X,''S(d L)'',6X,''k'',7x,''r(*)'',4x, &
       &      ''rho(*)'',3x,''log J''/1X,77(''_'')/)') OBJECT

  do J=1,N
     write(NLP,'(2X,2F8.2, 4F10.3,2F8.2)') &
          &    AMG(J),ALG(J),DLTL(J),SGML(J),FRAC(J),REQ(J),RHO(J),ALJ(J)
     ICRT=( ALG(J)+3.0001 )*10.0
     if( MOD(ICRT,10)==0 ) write(NLP,'(1H )')
  end do
  UNIT=1.0
  write(NLP,'(18X,3F10.3/'' '',1X,77(''_'')/)') DEL,TTL,UNIT
  SMESH=SQRT(AREA)
  write(nlp,'(7x,''Mesh size ='',f10.3,'' (arcmin)''/ &
       &      7x,''Re(*)  ='',f8.3,'' (arcmin),'', &
       &      3X,''Mue ='',f8.3,'' (mag/arcsec**2)'')') SMESH,RE(2),AMU(2)

!     ---- print a table of photometric parameters
  
  APMAG=-2.5*LOG10(TTL)+SKY-8.891
  
  write(NLP,'(a)') char(12)
  write(NLP,'(////10X,''********** Photometric parameters '', &
       &     ''of '',a20,''**********''//)') OBJECT(1:20)
  print '(''********** Photometric parameters '', &
       &    ''of '',a20,''**********'')', OBJECT(1:20)
 
  write(NLP,'(//15X,''Apparent total magnitude    :'',F8.2, &
       &     ''  (mag)'')') APMAG
  print '(''Apparent total magnitude    :'',F8.2,''  (mag)'')', APMAG
  
  write(NLP,'(//15x,''Threshold surface brightness:'',F8.2, &
       &     ''  (mag/arcsec**2)'')') AMG(N)
  print '(''Threshold surface brightness:'',F8.2, &
       &    ''  (mag/arcsec**2)'')', AMG(N)
 
  write(NLP,'(//15X,''Luminosity fraction k('',i2,'')   :'',F9.3)') IVF,FR25
  print '(''Luminosity fraction k('',i2,'')   :'',F9.3)', IVF,FR25
 
  write(NLP,'(//15X,''Observed peak brightness    :'',F8.2, &
       &     ''  (mag/arcsec**2)'')') AMG(1)
  print '(''Observed peak brightness    :'',F8.2, &
       &    ''  (mag/arcsec**2)'')', AMG(1)

  do J=1,3
     write(NLP,'(//15X,''Parameter at k='',a3)') CK(J)
     print '(''Parameter at k='',a3)', CK(J)
     write(NLP,'(/ 15X,''   Equivalent radius  '',a5,'' :'', &
          &      f9.3,'' (arcmin)'')') cr(j),re(j)
     print '(''   Equivalent radius  '',a5,'' :'', &
          &    f9.3,'' (arcmin)'')', cr(j),re(j)
     write(NLP,'(/ 15X,''   Surface brightness '',A3,''   :'', &
          &      f8.2,''  (mag/arcsec**2)'')') cmu(j),amu(j)
     print '(''   Surface brightness '',A3,''   :'', &
          &    f8.2,''  (mag/arcsec**2)'')', cmu(j),amu(j)
     if ( J==2 ) then
        SB = APMAG + 5.0*LOG10( RE(2) ) + 10.886
        write(NLP,'(/15X,''   Mean surface brightness  :'', &
             &      f8.2,''  (mag/arcsec**2)'')') sb
        print '(''   Mean surface brightness  :'', &
             &    f8.2,''  (mag/arcsec**2)'')', sb
     end if
  end do
  
  write(NLP,'(//15X,''Concentration indices'')')
  write(NLP,'(/ 15X,''         C21 = Re(*)/R1(*)  :'',F8.2)') C21
  write(NLP,'(/ 15X,''         C32 = R3(*)/Re(*)  :'',F8.2)') C32
  print *, 'Concentration indices'
  print '(''         C21 = Re(*)/R1(*)  :'',F8.2)', C21
  print '(''         C32 = R3(*)/Re(*)  :'',F8.2)', C32
  print *
  print '(''### Above parameters were written in '',a)', outfile
  
  return
END SUBROUTINE PRINTR

!---- PLOTEQ ----------------------------------------------------------
SUBROUTINE PLOTEQ(OBJECT,AMG,REQ,RHO,ALOGJ,N,hdev,hfile)
  character :: OBJECT*40, hdev*6, hfile*40
  real      :: AMG(51),REQ(51),RHO(51),ALOGJ(51),U(51),V(51)
  
  call PGBEGIN(0,hfile//hdev,2,1)
  call PGSCF(2)
  do NP=1,2
     do J=1,N
        if( NP==1 ) then
           U(J)=REQ(J)*60.0
           V(J)=AMG(J)
        else
           U(J)=RHO(J)
           V(J)=ALOGJ(J)
        end if
     end do
     ! ******* plot in linear scale
     u1=0.0
     if( NP==1 ) then
        U2=INT(U(N)/10.0+1.0)*10
        V1=26.0
        V2=14.0
        call PGENV(u1,u2,v1,v2,-2,-2)
        call PGVPORT(0.15,0.85,0.15,0.85)
        xdum=u2*0.55
        ydum=v2+(v1-v2)*.25
        call PGTEXT(xdum,ydum,OBJECT)
        call PGLABEL('R (arcsec)','\\gm (mag/arcsec\\u2\\d)', &
             &       'Equivalent Profile')
     else
        U2= 5.0
        V1=-1.5
        V2= 2.0
        call PGENV(u1,u2,v1,v2,-2,-2)
        call PGVPORT(0.15,0.85,0.15,0.85)
        xdum=u2*0.4
        ydum=v1+(v2-v1)*.8
        xdum=u2*0.45
        ydum=v1+(v2-v1)*.75
        call PGTEXT(xdum,ydum,OBJECT)
        call PGLABEL('\\gr','log J','Reduced Equivalent Profile')
     end if
     call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
     call PGPT(n,u,v,17)
     
     ! ******* plot in 1/4-power scale
     do J=1,N
        if( NP==1 ) U(J)=( REQ(J)*60.0 )**(0.25)
        if( NP==2 ) U(J)=RHO(J)**(0.25)
     end do
     if( NP==1 ) then
        U2=INT( U(N)*2.0+1.0 )/2.0
        call PGENV(u1,u2,v1,v2,-2,-2)
        call PGVPORT(0.15,0.85,0.15,0.85)
        xdum=u2*0.55
        ydum=v2+(v1-v2)*.25
        call PGTEXT(xdum,ydum,OBJECT)
        call PGLABEL('R\\u1/4\\d (arcsec)','\\gm (mag/arcsec\\u2\\d)', &
             &       'Equivalent Profile')
     else
        U2=2.0
        call PGENV(u1,u2,v1,v2,-2,-2)
        call PGVPORT(0.15,0.85,0.15,0.85)
        xdum=u2*0.4
        ydum=v1+(v2-v1)*.8
        xdum=u2*0.45
        ydum=v1+(v2-v1)*.75
        call PGTEXT(xdum,ydum,OBJECT)
        call PGLABEL('\\gr\\u1/4','log J','Reduced Equivalent Profile')
     end if
     call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
     call PGPT(n,u,v,17)
  end do
  
  !----    Finish the plot
  if ( hdev=='/vlips' ) then
     print *, '### Graph(LIPS2) was written in '//hfile
  else
     print *, '### Graph(PostScript) was written in '//hfile
  end if
  
  
  call PGEND
  
  return
END SUBROUTINE PLOTEQ
