program imgdisp
  
  ! Original version by M. Hamabe 1999-07-23 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-07-13 (for Fortran90)
  ! Updated by M. Hamabe  2007-10-23 (opninp)

  real, allocatable :: ZG(:,:)
  integer   :: bitpix
  character :: TITLE*40, image*80, magscale*5, ok
  character :: device*20, c_type1*10, c_type2*10
  
  irc=0              ! initial value for return code 
  IFLG=-999          ! flag for the window which is not opened yet
  device='/XWINDOW'  ! device for display/plot
  ipal=3             ! default color palett
  bright=0.5         ! default grightness
  contrast=1.0       ! default contrast
  sign=+1.0          ! sign of the contrast
  icolor=0           ! default hardcopy mode (mono)
  mosaic=0           ! input-file is a single FITS file
  IW1=IFLG           ! wiondow-1 is not opened yet
  IW2=IFLG           ! wiondow-2 is not opened yet
  IZM=1              ! initial zooming factor
  isd=1
  jsd=1
  nfx=1
  nfy=1
  lastplot = 0
  
  call opninp (1,im,0,image,title,iext,jext,irc)
  if ( irc/=0 ) go to 999
  iextd=iext
  jextd=jext
  call CLARGC (2, magscale, irc)
  if ( irc /= 0 ) then
     magscale='no'
     irc=0
  end if
  if ( magscale == 'yes' ) then 
     call GETKEYE(im,'UNIT-MAG', sky, irc)
123  if ( irc /= 0 ) then
        print '(''Enter unit magnitude (sky, if Isky=1)  ===> '',$)'
        read *, sky
        irc=0
     end if
     print '(''pixel value = 1  <===> '',f7.3,'' mag arcsec**(-2)'')', sky
     if ( sky < 10.0 .or. sky > 30.0 ) then
        print '('' OK? (<y>/n) ===> '',$)'
        read '(a)', ok
        if ( ok == 'n' ) then
           irc=1
           go to 123
        end if
     end if
  end if
  
  allocate( ZG(iext,jext) )
  CALL MATRD(im,zg,iext,jext,irc)
  if ( irc /= 0 ) go to 999
  
  call HELP
  iextd=iext
  jextd=jext
  call set_z1z2(ZG,iext,jext,bitpix,bzero,bscale,gmin0,gmax0,gmin,gmax,magscale)
  
  gnull=100.0
  if ( magscale == 'yes' ) then
     if ( gmin < 0 ) then
        gmin=gnull
     else
        gmin=-2.5*log10(gmin)+sky
     end if
     gmax=-2.5*log10(gmax)+sky
     gmin=float(int(gmin*2+0.5))/2.0
     gmax=float(int(gmax*2+0.5))/2.0
     gmin0=gmin
     gmax0=gmax
  end if
  
  if ( magscale == 'yes' ) call tomag(ZG,iext,jext,sky,gnull)
  
  call win_defsize(iext,jext,width0,width,ratio)
  
  cr_val1=float(isd)
  cr_pix1=1
  c_type1='pixel'
  c_delt1=1
  cr_val2=float(jsd)
  cr_pix2=1
  c_type2='pixel'
  c_delt2=1
  
  call showimg(IW1,IW2,ZG,TITLE,IFLG,mosaic,nfx,nfy, &
       &   cr_val1,cr_pix1,c_type1,c_delt1, &
       &   cr_val2,cr_pix2,c_type2,c_delt2, &
       &   device,width0,width,ratio,iext,jext,isd,jsd, &
       &   iextd,jextd,gmin0,gmax0,gmin,gmax,ipal,bright,contrast,sign, &
       &   icolor,izm,lastplot,irc)
  
999 if (irc>1) call PUTEMSG(irc)
  
end program imgdisp
