program isophotes

  ! Original version by M. Hamabe2001-09-07 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-09-25 (for Fortran90)
  ! Updated by M. Hamabe  2007-10-23 (opninp)

  PARAMETER (MAXPLT=256)
  
  real, allocatable :: GR(:,:), buff(:), pix(:)
! pointer   (ptr1, GR), (ptr3, buff), (ptr4, pix)
!      integer   malloc, ptr1, ptr3, ptr4

  character image*80
  character TITLE0*40, TITLE*40, chl, edl
  character cntpar*40, editor*10, interact*5, magscale*5
  character device*10, hdev*6, hfile*40, cline*10
  character hcopy*5, pid*5, show*5, tick*5
  integer  	im, irc, hard
  
  real    :: clev(50), TR(6), dlev(50), bf(50)
  
  lin=11
  
  !----  get parameters -----------------------------------------
  call opninp (1,im,0,image,title0,iext,jext,irc)
  if ( irc/=0 ) go to 999
  
  call CLARGC (2, cntpar, irc)
  if ( irc /= 0 ) then
     print '(''Table of contour levels ===> '',$)'
     read '(a)', cntpar
  end if
  call CLARGC (3, magscale, irc)
  if ( irc /= 0 ) magscale='yes'
  call CLARGC (4, interact, irc)
  if ( irc /= 0 ) interact='yes'
  call CLARGC (5, show, irc)
  if ( irc /= 0 ) show='yes'
  call CLARGC (6, device, irc)
  if ( irc /= 0 ) device='/xterm'
  if ( device(1:3) == 'tek' ) then
     device='/xterm'
  else if ( device(1:5) == 'xserv' ) then
     device='/xserve'
  else if ( device(1:4) == 'xwin' ) then
     device='/xwindow'
  else
     device='inq'
  end if
  call CLARGC (7, hcopy, irc)
  if ( irc /= 0 ) hcopy='no'
!      call CLARGC (8, hdev, irc)
  if ( iext>jext ) then
     hdev='/PS'
  else
     hdev='/VPS'
  end if
  call CLARGC (8, hfile, irc)
  if ( irc /= 0 ) then
     hfile='isophotes.ps'
  end if
  call CLARGC (9, pid, irc)
  if ( irc /= 0 ) pid='yes'
  itick=1
  call CLARGC (10, tick, irc)
  if ( irc /= 0 ) tick='yes'
  if ( tick /= 'yes' ) itick=0
  call CLARGC (11, editor, irc)
  if ( irc /= 0 ) editor='vi '
  call CLARGC (12, title, irc)
  if ( irc /= 0 ) title=title0
  !----  get parameters (end) -----------------------------------
  
  call GETKEYE(im,'CDELT1  ', cdelt1, irc)
  if ( irc /= 0 ) call GETKEYE(im,'SECPPIX ',cdelt1,irc)
  if ( irc /= 0 ) call GETKEYE(im,'CD1_1   ',cdelt1,irc)
  if ( irc == 0 ) then
     cdelt1=cdelt1*3600
  end if
  if ( irc /= 0 ) then
     print '(''Enter pixel scale (dx in arcsec/pixel) ===> '',$)'
     read *, cdelt1
     irc=0
  end if
  cdelt1=abs(cdelt1)
  if ( cdelt1 < 10/3600.0 ) cdelt1=cdelt1*3600.0
  
  call GETKEYE(im,'CDELT2  ', cdelt2, irc)
  if ( irc /= 0 ) call GETKEYE(im,'CD2_2   ',cdelt2,irc)
  if ( irc == 0 ) then
     cdelt2=cdelt2*3600
  end if
  if ( irc /= 0 ) then
     print '(''Enter pixel scale (dy in arcsec/pixel) ===> '',$)'
     read *, cdelt2
     irc=0
  end if
  cdelt2=abs(cdelt2)
  if ( cdelt2 < 10/3600.0 ) cdelt2=cdelt2*3600.0
  irc=0
  print '(''pixel size ='',f6.3,''" x'',f6.3,''"'')', cdelt1,cdelt2
  if ( magscale == 'yes' ) then 
     call GETKEYE(im,'EXPTIME', expt, irc)
     if ( irc /= 0 ) then
        print '(''Enter exposure time  ===> '',$)'
        read *, expt
        irc=0
     end if
     print '(''exposure = '',f7.2,''(sec)'')', expt
     call GETKEYE(im,'PHOTZERO', pzero, irc)
     if ( irc /= 0 ) then
        print '(''*** Photemetric ZERO-point (PZP) ***'')'
        print '(''  PZP is the magnitude corresponding to'',$)'
        print '('' 1 ADU/sec'')'
        print '(''Enter PZP  ===> '',$)'
        read *, pzero
     end if
     pzero=pzero+2.5*log10(cdelt1*cdelt1*expt)
     print '(''pixel value = 1  <===> '',f7.3,'' mag arcsec**(-2)'')', pzero
  end if
  irc=0
  
  !----------------------------------------------------------
  if ( IEXT > MAXPLT .or. JEXT > MAXPLT ) then
     krdf=(max(iext,jext)-1)/MAXPLT+1
     iext2=iext/krdf
     jext2=jext/krdf
     allocate( GR(iext2, jext2) )
     allocate( buff(iext) )
     allocate( pix(iext) )
     call RMATRD(im,GR,pix,buff,iext,jext,iext2,jext2,krdf,irc)
     deallocate(buff)
     deallocate(pix) 
  else
     iext2=iext
     jext2=jext
     krdf=1
     allocate( GR(iext2, jext2) )
     CALL MATRD(im,GR,iext2,jext2,irc)
  end if
  print '(''Image will be block averaged by '', &
       &     i1,'' in x and '',i1,'' in y'')', krdf,krdf
  
  !     *** SELECT PROCESS ***
  
  hard=0
  
  !     Terminal
  if ( show == 'yes' ) then
     if ( device == 'inq' ) then
        call PGBEG(0,'?',1,1)
     else
        call PGBEG(0,device,1,1)
     end if
  else
     call PGBEG(0,'/NULL',1,1)
  end if
  
  !---- Set the user coordinates and make a coordinate box
3481 close (lin)
  open (lin,file=cntpar,access='SEQUENTIAL')
  !     read (lin,*,end=888) clev(1)
  read (lin,'(a)',end=888) cline
  if ( cline == '' ) go to 888
  bf(1)=0
  if ( cline(1:1) == '+' ) bf(1)=1
  read(cline,*,end=529) clev(1)
  
  print *
  do i=2,50
     !        read (lin,*,end=529) clev(i)
     read (lin,'(a)',end=529)  cline
     if ( cline=="" ) go to 529
     bf(i)=0
     if ( cline(1:1) == '+' ) bf(i)=1
     read (cline,*,end=529) clev(i)
  end do
888 continue
  close(lin)
  print *, ' Edit the file for contour levels '
  print *, '   Give 1 level in 1 line '
  print '(''   Press ENTER-key when ready'',$)'
  read '(a)'
  call system(editor//' '//cntpar)
  goto 3481
529 close(lin)
  nlev=i-1
  if ( chl /= 'y' ) call prtlvl(clev,nlev)
  if ( interact /= 'no' ) then
     if ( chl /= 'y' ) then
        print '(''    Edit ?  (y/<n>) ===> '',$)'
        read '(a)', edl
     end if
     if ( edl == 'y'.or.chl == 'y' ) then
        call system(editor//' '//cntpar)
        chl='n'
        edl='n'
        goto 3481
     end if
  end if
  if ( magscale == 'yes' ) then
     do i=1,nlev
        clev(i)=10.0**( (pzero-clev(i))/2.5 )
     end do
  end if
  nlevd=0
  do i=1,nlev
     if ( bf(i) == 1 ) then
        nlevd=nlevd+1
        dlev(nlevd)=clev(i)
     end if
  end do
  
  if ( show == 'no' ) goto 2000
  
  xxx=float(iext2)/2.0*cdelt1*krdf
  yyy=float(jext2)/2.0*cdelt2*krdf
  call PGWNAD(-xxx,xxx,-yyy,yyy)
  if ( itick == 1 ) then
     call PGBOX('BCST',0.0,-1,'BCSTV',0.0,-1)
  else
     call PGBOX('BC',0.0,-1,'BCV',0.0,-1)
  end if
1000 continue
  call PGLAB(title,' ',' ')
  TR(1)=-xxx
  TR(2)=cdelt1*krdf
  TR(3)=0.0
  TR(4)=-yyy
  TR(5)=0.0
  TR(6)=cdelt2*krdf
  call PGCONT(GR,iext2,jext2,1,iext2,1,jext2,clev,nlev,TR)
  if ( nlevd /= 0 ) then
     call PGSLW(4)
     call PGCONT(GR,iext2,jext2,1,iext2,1,jext2,dlev,nlevd,TR)
     call PGSLW(1)
  end if
  if ( hard == 1 .and. pid /= 'no' ) call PGIDEN
  if ( hard == 0 )then
     if ( interact /= 'no' ) then
        print '(a,$)', 'Change levels?  (y/<n>) ===> '
        read '(a)', chl
        if ( chl == 'y' )then
           call PGEND
           if ( device == 'inq' ) then
              call PGBEG(0,'?',1,1)
           else
              call PGBEG(0,device,1,1)
           end if
           go to 3481
        end if
     end if
     call PGEND
     
     if ( hcopy == 'yes' ) hard=1
     if ( hard == 1 ) then
        xxx=float(iext2)/2.0*cdelt1*krdf
        yyy=float(jext2)/2.0*cdelt2*krdf
        call PGBEG(0,hfile//hdev,1,1)
        call PGSCF(2)
        call PGWNAD(-xxx,xxx,-yyy,yyy)
        call PGSLW(1)
        if ( itick == 1 ) then
           call PGBOX('BCST',0.0,-1,'BCSTV',0.0,-1)
        else
           call PGBOX('BC',0.0,-1,'BCV',0.0,-1)
        end if
        go to 1000
     end if
  end if
  go to 3000
  
2000 if ( hcopy == 'yes' ) hard=1
  if ( hard == 1 ) then
     xxx=float(iext2)/2.0*cdelt1*krdf
     yyy=float(jext2)/2.0*cdelt2*krdf
     call PGBEG(0,hfile//hdev,1,1)
     call PGSCF(2)
     call PGWNAD(-xxx,xxx,-yyy,yyy)
     call PGSLW(1)
     if ( itick == 1 ) then
        call PGBOX('BCST',0.0,-1,'BCSTV',0.0,-1)
     else
        call PGBOX('BC',0.0,-1,'BCV',0.0,-1)
     end if
     go to 1000
  end if
  
3000 if ( hard == 1 ) then
     !----    Finish the plot
     call PGEND				! Finish the plot
     print *, '### Output(PostScript) was written in '//hfile
  end if
  
  deallocate(GR)                       !   call free(ptr1)
  
9000 call PGEND
  STOP
999 call PUTEMSG(irc)
  stop
  
END program isophotes
!-------------------------------------------------------------------------
subroutine prtlvl(clev,nlev)
  
  dimension clev(nlev)
  
  n=min(nlev,7)
  print '(''         '',7(i5,5x,:))',  ( i,       i=1,n )
  print '(''level :  '',7(g10.5,:))',  ( clev(i), i=1,n )
  
  do k=1, 10
     if ( nlev >  7*k ) then
        n=min(nlev,7*(k+1))
        print '(''         '',7(i5,5x,:))', ( i,       i=7*k+1,n )
        print '(''level :  '',7(g10.5,:))', ( clev(i), i=7*k+1,n )
     end if
  end do
  
  return
end subroutine prtlvl
!------------------------------------------------------------------
SUBROUTINE RMATRD(im,g,pix,buff,iext1,jext1,iext2,jext2,krdf,irc)
  integer   group
  dimension pix(iext1), buff(iext1), g(iext2,jext2)
  
  !     *** Reject too large reduction factor ***
  if( krdf > 20 ) then
     irc=1000
     return
  end if
  !     *** Reject unmatched size ***
  if( iext2*krdf > iext1 .or. jext2*krdf > jext1 ) then
     irc=2000
     return
  end if
  
  !     *** Initialize output matrix ***
  g(1:iext2,1:jext2) = 0.0
  
  !     *** reduction ***
  rdf2=krdf*krdf
  
  group=1
  nelements=iext1
  nullval=0
  do j=1, jext2
     buff(1:iext1)=0.0
     do jj=1, krdf
        jdum=(j-1)*krdf+jj
        call FTGPVE(im,group,(jdum-1)*iext1+1,nelements,nullval,pix,anyf,irc)
        do ii=1, iext1
           buff(ii)=buff(ii)+pix(ii)
        end do
     end do
     do i=1, iext2
        dum=0.0
        do ii=1, krdf
           idum=(i-1)*krdf+ii
           dum=dum+buff(idum)
        end do
        g(i,j)=dum/rdf2
     end do
  end do
  
  irc=0
  
  return
end SUBROUTINE RMATRD

