program prfplot
  
  !     program to plot the profiles produced using profimg & mmprof task.
  
  ! Original version by M. Hamabe 1994-09-02 (SPIRAL version2.6)
  ! Updated by H. Shimizu 2007-10-19 (for Fortran90)
  ! Checked by M. Hamabe  2007-10-22
  
  character*80 cline, tabl, tabfile, extend
  character    char, title*40, band*2, cstar*25, VSTAR*16
  character    S1*18, S2*30, yn
  character    pid*3, capon*3, prflabel(7)*40, device*10
  character    hdev*6, hfile*40
  integer      RSTYLE(0:9), STYLE(7)
  dimension    ndata(7), ipk(7)
  dimension    r(1000,3),amag(1000,7)
  dimension    xp(1000),yp(1000), ltype(7)
  dimension    SR(300), SLOGR(300), SR4(300),SMU(300,3)
  logical      there
  ! symbol codes :=  fc   oc   fs   os   x   +   ft   ot   *    .
  DATA RSTYLE  /17, 21, 16, 0, 5, 2, 13, 7, 3, 1/
  
  LIN=11
  
  VSTAR= '\\gs\\dstar \\u='
  NSTAR = 0
  
  kflag=0
  ltype=1
  prflabel='Profile No.                             '
  do j=1, 7
     ipk(j)=j-1
     STYLE(j)=RSTYLE( ipk(j) )
     write(prflabel(j)(12:13),'(i2)') j
  end do
  
  call clargc (1, tabl, irc)
  if ( irc/=0 ) then
     print '(''Enter output profile-table name: '',$)'
     read *, tabl
  end if
  tabfile=extend(tabl,'prf')
  open (LIN, file=tabfile)
  
  call clargc (2, device, irc)
  if ( irc/=0 ) device='/xwindow'
  if ( device(1:3)=='xse' ) then
     device='/xserve'
  else if ( device(1:4)=='xwin' ) then
     device='/xwindow'
  else
     device='inq'
  end if
  
  hdev='/PS'

  call clargc (3, hfile, irc)
  if ( irc/=0 ) then
     hfile='prfplot.ps'
  end if
  
  call clargi (4,KIND,irc)
  if ( irc/=0 ) KIND=1
  
  call clargc (5,pid,irc)
  if ( irc/=0 ) pid='yes'
  
  call clargc (6,capon,irc)
  if ( irc/=0 ) capon='yes'
  call clargr (7,xof,irc)
  call clargr (8,yof,irc)
  
  !---- read title
  read (lin,'(a)') cline
  read (cline(14:53),'(a)') title
  print '(''Title of original image: '',a)', title
  print '(''Is the title ok ? (<y>/n) ===> '',$)'
  READ '(A1)', YN
  IF (YN=='n') THEN
     PRINT *, '       ----+----+----+----+----+----+----+----+'
     print '(''Title: '',$)'
     READ '(A40)', TITLE
  ENDIF
  
  read (lin,'(a)') cline
  read (cline(8:9),'(a2)') band
  S2='\\gm\\d'//BAND//'\\u  (mag arcsec\\u-2\\d)'
  read (lin,'(a)') cline
  !---- read numbers of profiles and data points in profiles
  read (lin,'(a)') cline
  read (cline(25:80),'(7i8)') ndata
  nprf=0
  nmax=0
  do j=1,7
     if ( ndata(j)>0 ) nprf=nprf+1
     if ( ndata(j)>nmax ) nmax=ndata(j)
  end do
  print '(''# of profiles ='',i2)', nprf
  print *, '# of data in profiles =', ( ndata(i), i=1,nprf )
  print '(''Max. # of data points ='',i4)', nmax
  print *
  !---- read profile
  do j=1,7
     read (lin,'(a)') cline
  end do
  do j=1, nmax
     read (lin,'(10f8.0)') ( r(j,k), k=1,3 ),( amag(j,k), k=1,nprf )
  end do
  !---- plot profiles
  if ( device=='INQ' ) then
     call PGBEG(0,'?'//device,1,1)
  else
     call PGBEG(0,device,1,1)
  end if
  YMIN0=999.9
  YMAX0=-999.9
  DO j=1,nprf
     DO i=1, ndata(j)
        dum=amag(i,j)
        if ( dum<100.0 ) then
           if ( dum<ymin0 ) ymin0=dum
           if ( dum>ymax0 ) ymax0=dum
        end if
     END DO
  END DO
  ymin0=float(int(ymin0-1.0))
  ymax0=ymin0+float(int(ymax0-ymin0+1))
  if ( ymax0-ymin0>10.0 ) ymax0=ymin0+10.0
1000 continue
1001 continue
  if ( KIND==1 ) then
     XMIN0=0.0
     XMAX0=r(nmax,KIND)
     S1='    R (arcsec)    '
  else if ( KIND==2 ) then
     XMIN0=-1.0
     XMAX0=r(nmax,KIND)
     S1='  log R (arcsec)  '
  else if ( KIND==3 ) then
     XMIN0=0.0
     XMAX0=r(nmax,KIND)
     S1='R (arcsec)\\u1/4\\d'
  end if
  if ( kflag==0 ) then
     XMIN=XMIN0
     XMAX=XMAX0
     YMIN=YMIN0
     YMAX=YMAX0
     kflag=1
  end if
  call PGSCH(1.)
  call PGENV(Xmin,Xmax,Ymax,Ymin,-2,-2)
  if (CHAR=='h' ) then
     call PGVPORT(0.15,0.85,0.15,0.85)
  else
     call PGVSTAND
  end if
  call PGSLW(1)
  call PGSCH(1.01)
  call PGBOX('BCNST',0.0,-1,'BCNSTV',0.0,-1)
  call PGSLW(1)
  if ( pid=='yes' ) call PGIDEN
  call PGLAB(S1,S2,title)
  !---- Plot points
  Xrange=Xmax-Xmin
  Yrange=Ymax-Ymin
  xdum=Xmin+Xrange*xof
  ydum=Ymin+Yrange*yof
  ddy=Yrange*0.01
  
  do j=1,nprf
     if ( capon=='yes' ) then
        if ( ipk(j)>=0 ) then
           call PGPT(1,xdum,ydum+(j-1)*Yrange*0.03,STYLE(j))
        else
           call PGSLS(ltype(j))
           xp(1)=xdum-Xrange*0.04
           xp(2)=xdum+Xrange*0.02
           yp(1)=ydum+(j-1)*Yrange*0.03
           yp(2)=ydum+(j-1)*Yrange*0.03
           call PGLINE(2,xp,yp)
           call PGSLS(1)
        end if
        call PGTEXT(xdum+Xrange*0.03,ydum+(j-1)*Yrange*0.03+ddy,prflabel(j))
     end if
     
     do i=1, ndata(j)
        xp(i)=r(i,KIND)
        yp(i)=amag(i,j)
     end do
     
     if ( ipk(j)>=0 ) then
        call PGPT(ndata(j),xp,yp,STYLE(j))
     else
        call PGSLS(ltype(j))
        call PGLINE(ndata(j),xp,yp)
        call PGSLS(1)
     end if
  end do
  
  if ( NSTAR>=1 ) then
     call PGTEXT(xmin+0.75*(xmax-xmin),ymin+0.1*(ymax-ymin),Cstar)
     do  I = 1, 300
        if(KIND==1) xp(I)=   SR(I)
        if(KIND==2) xp(I)=SLOGR(I)
        if(KIND==3) xp(I)=  SR4(I)
        yp(I)=SMU(I,1)
     end do
     call PGSLW(1)
     call PGSLS(4)
     call PGLINE(300,xp,yp)
     call PGSLW(1)
     call PGSLS(1)
  end if
  
  if ( CHAR=='h' ) call PGBEG(0,device,1,1)
  
  !====== INTERACTIVE SECTION =====================================
  !
  !
2000 CONTINUE
  print '(''command: '',$)'
  read '(A)', CHAR                       ! COMMAND INPUT
  
  if ( CHAR=='p' ) then                     ! REPLOT
     go to 1000
  else if ( CHAR=='h' ) then                ! MAKE COPY ON LASER PRINTER
     if ( hdev=='/lips2' ) then
        inquire (file=hfile, exist=there)
        if ( there ) call system('/bin/rm '//hfile//' >/dev/null')
     end if
     call PGBEG(0,hfile//hdev,1,1)
     call PGSCF(2)
     go to 1001
  else if ( CHAR=='k' ) then
     print *, ' Kind of plot   (1=linear,2=log r,3=r^(1/4) )'
     print '(''kind = '',$)'
     read *, KIND
     if ( KIND<1 .OR. KIND>3 ) KIND=1
     kflag=0
     go to 1000
  else if ( CHAR=='x' ) then               ! CHANGE X-SCALE
     print '(''  inner and outer limit = '',$)'
     read *, XMIN, XMAX
     go to 1000
  else if ( CHAR=='y' ) then               ! CHANGE Y-SCALE
     print '(''  brightest and faintest limits = '',$)'
     read *, YMIN, YMAX
     go to 1000
  else if( CHAR=='.' ) then                ! Change kind of dots
     print *, 'KIND of plot symbol:  '
     print *, '  (0=filled circle,   1=open circle,  '
     print *, '   2=filled square,   3=open square,  ' 
     print *, '   4=cross[x],        5=plus[+],      '
     print *, '   6=filled triangle, 7=open triangle,'
     print *, '   8=asterisk,        9=small dot,    '
     print *, '  -1=full line,      -2=dashed line,  '
     print *, '  -3=dot-dash line,  -4=dotted line,'
     print *, '  -5=dash-dot-dot-dot line '
     if ( nprf>1 ) then
        print '(''profile no = '',$)'
        read *, j
     else
        j=1
     end if
     if ( j>=1 .and. j<=nprf ) then
        print '(''  current symbol code ='',I2)', ipk(j)
        print '(''  Enter new symbol code = '',$)'
        read *, ipk(j)
        if ( ipk(j)<-5 .or. ipk(j)>9 ) go to 2000
        if ( ipk(j)>-1 ) then
           STYLE(j)=RSTYLE( ipk(j) )
        else
           ltype(j)=-ipk(j)
           if ( ltype(j)<0 .or. ltype(j)>6 ) goto 2000
        end if
     end if
     go to 2000
  else if ( CHAR=='c' ) then
     print '(''profile no = '',$)'
     read *, j
     if ( j>=1 .and. j<=nprf ) then
        print '(''  current caption : ='',a40)', prflabel(j)
        print '(''  Enter new caption = '',$)'
        read  '(a)', prflabel(j)
     end if
     go to 2000
     !-------------------------------------
  else if ( CHAR=='*' ) then                      ! PLOT STAR PROFILE
4000 print '(''  sigma star = '',$)'
  read *, SIG
  if ( SIG<=0.0001 .OR. SIG>10. ) then
     NSTAR = 0
     go to 1000
  end if
  NSTAR = 1
  SSS = 0.542868/SIG**2                          ! 0.542868 = 2.5*log(e)/2
  do I = 1, 300
     SMU(I,1) = (I-1) * 0.04
     if(SMU(I,1) <= 0.001) SMU(I,1) = 0.001
     SR (I)   = SQRT(SMU(I,1)/SSS)
     SLOGR(I) = LOG10(SR(I))
     SR4  (I) = SQRT(SQRT(SR(I)))
     SMU(I,1) = SMU(I,1) + amag(1,1)
  end do
  write(cstar,'(A14,F5.2,a1)') VSTAR,SIG,'"'
  go to 1000
  !-------------------------------------
else if ( CHAR=='?' ) then
   call HELP_P
   go to 2000
else if ( CHAR=='q' ) then
   go to 9000
else
   print '(1X,''valid responses are '',''c,h,k,p,q,x,y,*,.,?,<cr>'')'
   go to 2000
end if
9000 call PGEND

stop
end program prfplot

!**********************************************************************
subroutine HELP_P

  !       This routine prints the Help messages on the display.

  character H1(7)*60, H2(4)*60
  DATA H1 / &
       & 'OPTIONS:  ? = Type this HELP listing                        ', &
       & '          p = Replot current graph                          ', &
       & '          k = Kind of X-axis                                ', &
       & '              1 = linear, 2 = logarithmic, 3 = r^(1/4)      ', &
       & '          x = Change boundaries of x-axis                   ', &
       & '          y = Change boundaries of y-axis                   ', &
       & '          . = Change plot symbols,                          '/
  DATA H2/ &
       & '          c = Change captions of symbols                    ', &
       & '          * = Plot Gaussian stellar profile                 ', &
       & '          h = Make a hardcopy file of the plot              ', &
       & '          q = Quit from this program                        '/
  
  do I=1,7
     print '('' '',A60)', H1(I)
  end do
  do I=1,4
     print '('' '',A60)', H2(I)
  end do
  
  return
end subroutine HELP_P
